unit agMFU;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
 ExtCtrls, Spin, ExtDlgs, ComCtrls, EditBtn, vvvTrainingOCR, vvvImageGr, vvvOCR,
 vvvRegNum, dateutils;

type

 { TmainFrm }

 TmainFrm = class(TForm)
  acCheckBox: TCheckBox;
  autoRatioCheckBox: TCheckBox;
  angleCheckBox: TCheckBox;
  as0CheckBox: TCheckBox;
  Button1: TButton;
  clearBtn: TButton;
  cpyToTestCheckBox: TCheckBox;
  Panel6: TPanel;
  ratioCheckBox: TCheckBox;
  quietCheckBox: TCheckBox;
  videoOCRresult: TEdit;
  videoSrcEdit: TEditButton;
  videoImage: TImage;
  invCheckBox: TCheckBox;
  Label10: TLabel;
  Label11: TLabel;
  Label6: TLabel;
  Label7: TLabel;
  Label8: TLabel;
  Label9: TLabel;
  Panel5: TPanel;
  minHEdit: TSpinEdit;
  minWEdit: TSpinEdit;
  maxHEdit: TSpinEdit;
  maxWEdit: TSpinEdit;
  minKWHEdit: TSpinEdit;
  maxKWHEdit: TSpinEdit;
  startBtn: TButton;
  saveBtn: TButton;
  autoAngleCheckBox: TCheckBox;
  loadPhotoBtn: TButton;
  TabSheet3: TTabSheet;
  testBtn: TButton;
  testSpeedBtn: TButton;
  Label5: TLabel;
  resultLabel: TLabel;
  OpenPhotoDialog: TOpenPictureDialog;
  weightEdit: TSpinEdit;
  testImage: TImage;
  Panel3: TPanel;
  Panel4: TPanel;
  symbolsEdit: TEdit;
  proportionEdit: TFloatSpinEdit;
  srcSymbImage: TImage;
  resizedSymbImage: TImage;
  resultSymbImage: TImage;
  Label1: TLabel;
  Label2: TLabel;
  Label3: TLabel;
  Label4: TLabel;
  OpenFontPictureDialog: TOpenPictureDialog;
  PageControl1: TPageControl;
  progressLabel: TLabel;
  Panel1: TPanel;
  Panel2: TPanel;
  minHeightEdit: TSpinEdit;
  maxHeightEdit: TSpinEdit;
  angleEdit: TSpinEdit;
  TabSheet1: TTabSheet;
  TabSheet2: TTabSheet;
  leftTrackBar: TTrackBar;
  rightTrackBar: TTrackBar;
  topTrackBar: TTrackBar;
  bottomTrackBar: TTrackBar;
  procedure autoAngleCheckBoxChange(Sender: TObject);
  procedure autoRatioCheckBoxChange(Sender: TObject);
  procedure Button1Click(Sender: TObject);
  procedure clearBtnClick(Sender: TObject);
  procedure PageControl1Change(Sender: TObject);
  procedure startBtnClick(Sender: TObject);
  procedure saveBtnClick(Sender: TObject);
  procedure loadPhotoBtnClick(Sender: TObject);
  procedure FormCreate(Sender: TObject);
  procedure srcSymbImageClick(Sender: TObject);
  procedure testBtnClick(Sender: TObject);
  procedure testSpeedBtnClick(Sender: TObject);
  procedure topTrackBarChange(Sender: TObject);
  procedure videoSrcEditButtonClick(Sender: TObject);
  procedure videoSrcEditChange(Sender: TObject);
  procedure weightEditChange(Sender: TObject);
 private
  trainingOCR: TTrainingOCR;
  testOCR: TplateFinder;
  grayImage: TbmpGrayImage;
  srcImage: TBitmap;
  fAngle: integer;
  fRatio: byte;
  testText: string;
  procedure processLine(bmp: TBitmap);
  procedure doTest;
  procedure doDisplayPositions;
  procedure doPrepareOCR;
  procedure onOptimize(Sender: TObject);
 public
  procedure ImageReady(Image: TMemoryStream; gray: PByte; w, h: cardinal);
 end;

var
 mainFrm: TmainFrm;

implementation

{$R *.frm}
{
uses camStream, camImageDecoder,
  libavutil_frame, libavcodec, libavutil_pixfmt, libswscale, libavutil_mem,
  libavutil_imgutils, libavutil_dict;
}
type
 TblGrImg = class(TbmpGrayImage)
 public
  procedure Blur;
  procedure Normalize; override;
 end;
{
 TcamJpegEncoder = class(TcamImageDecoder)
 private
  fPreviewWidth, fPreviewHeight: integer;
  fPreviewSize: cardinal;
  previewCtx: PSwsContext;
  imageCompCtx: PAVCodecContext;
  pts: int64;
  fOwner: TmainFrm;
  procedure updImage(Sender: TObject);
 protected
  fPreviewData: array[0..AV_NUM_DATA_POINTERS-1] of PByte;
  fPreviewLineSize: array[0..AV_NUM_DATA_POINTERS-1] of integer;
 protected
  procedure AfterCamChange; override;
  procedure PrepareConverter; override;
  procedure ProcessPacket(const aPacket: TAVPacket); override;
 public
  needed: boolean;
  image: TMemoryStream;
 public
  constructor Create(aCam: TcamStream; aOwner: TmainFrm); overload;
  property previewSize: cardinal read fPreviewSize;
  property previewData: PByte read fPreviewData[0];
  property previewWidth: integer read FpreviewWidth;
  property previewHeight: integer read FpreviewHeight;
 end;
}


const
 ocrFN: string = 'vvvOCR.chr';
 defPictWidth = 640;

procedure TblGrImg.Blur;
var
 x, y: cardinal;
 dt: TBytes;
begin
 setLength(dt, length(Data));
 move(Data[0], dt[0], length(Data));
 for y:= 1 to Height - 2 do for x:= 1 to Width - 2 do
  dt[x + y * width]:= round((Pixel[x,y] + 0.5 * Pixel[x - 1,y] + 0.5 * Pixel[x + 1,y] +
    0.5 * Pixel[x,y - 1] + 0.25 * Pixel[x - 1,y - 1] + 0.25 * Pixel[x + 1,y - 1] +
    0.5 * Pixel[x,y + 1] + 0.25 * Pixel[x - 1,y + 1] + 0.25 * Pixel[x + 1,y + 1]) / 4);
 y:= Height - 1;
 for x:= 1 to Width - 2 do begin
  dt[x] := round((Pixel[x,0] + 0.5 * Pixel[x - 1,0] + 0.5 * Pixel[x + 1,0] +
    0.5 * Pixel[x,1] + 0.25 * Pixel[x - 1,1] + 0.25 * Pixel[x + 1,1]) / 3);
  dt[x + y * width]:= round((Pixel[x,y] + 0.5 * Pixel[x - 1,y] + 0.5 * Pixel[x + 1,y] +
    0.5 * Pixel[x,y - 1] + 0.25 * Pixel[x - 1,y - 1] + 0.25 * Pixel[x + 1,y - 1]) / 3);
 end;
 x:= Width - 1;
 for y:= 1 to Height - 2 do begin
  dt[y * width]:= round((Pixel[0,y] + 0.5 * Pixel[1,y] +
    0.5 * Pixel[0, y - 1] + 0.25 * Pixel[1, y - 1] +
    0.5 * Pixel[0, y + 1] + 0.25 * Pixel[1, y + 1]) / 3);
  dt[x + y * width]:= round((Pixel[x,y] + 0.5 * Pixel[x - 1,y] +
    0.5 * Pixel[x,y - 1] + 0.25 * Pixel[x - 1,y - 1] +
    0.5 * Pixel[x,y + 1] + 0.25 * Pixel[x - 1,y + 1]) / 3);
 end;
 move(dt[0], Data[0], length(Data));
 setLength(dt, 0);
end;

procedure TblGrImg.Normalize;
var
 mn, mx: byte;
 k: extended;
 c, xc: integer;
begin
 mn:= 255; mx:= 0;
 for c:= 0 to Width * Height - 1 do begin
  if (Data[c] > mx) and (Data[c] < 255) then mx:= Data[c];
  if Data[c] < mn then mn:= Data[c];
 end;
 if (mn > 0) or (mx <= 220) then begin
  if mx <= 220 then k:= 220 / (mx - mn)
  else k:= 255 / (mx - mn - 10);
  for c:= 0 to Width * Height - 1 do begin
   xc:= round((Data[c] - mn - 10) * k);
   if xc < 0 then xc:= 0;
   if xc > 255 then Data[c]:= 255 else Data[c]:= xc;
  end;
  DataChanged;
 end;
end;

//########################################################### TcamJpegEncoder
{
constructor TcamJpegEncoder.Create(aCam: TcamStream;
  aOwner: TmainFrm);
begin
 inherited Create(aCam);
 imageCompCtx:= nil;
 needed:= True;
 pts:= 0;
 previewCtx:= nil;
 fPreviewSize:= 0;
 fPreviewWidth:= 640;
 fOwner:= aOwner;
 setWidth(1280);
 OnAfterProcess:= @updImage;
end;

procedure TcamJpegEncoder.AfterCamChange;
begin
 inherited;
 if assigned(previewCtx) then sws_freeContext(previewCtx);
 previewCtx:= nil;
 if fPreviewSize > 0 then av_freep(@fPreviewData);
 fPreviewSize:= 0;
 if assigned(imageCompCtx) then avcodec_close(imageCompCtx);
 imageCompCtx:= nil;
 needed:= False;
end;

procedure TcamJpegEncoder.PrepareConverter;
var
 codec: PAVCodec;
 x: integer;
begin
 codec:= avcodec_find_encoder(AV_CODEC_ID_MJPEG);
 if assigned(codec) then begin
  if codec^.pix_fmts^ = AV_PIX_FMT_NONE
  then codec^.pix_fmts^:= AV_PIX_FMT_YUVJ422P;
  fPixFormat:= codec^.pix_fmts^;
  inherited;
  if Size > 0 then begin
   fPreviewHeight:= round(fPreviewWidth * Height / Width);
   previewCtx:= sws_getContext(
    Width, Height, fPixFormat,
    previewWidth, previewHeight, AV_PIX_FMT_GRAY8,
    SWS_BILINEAR, nil, nil, nil);
   x:= av_image_alloc(@fPreviewData, @fPreviewLineSize, fPreviewWidth,
     fPreviewHeight, AV_PIX_FMT_GRAY8, 4);
   if x < 0 then begin
    AfterCamChange;
    exit;
   end;
   fPreviewSize := x;
   imageCompCtx:= avcodec_alloc_context3(codec);
   if assigned(imageCompCtx) then begin
    imageCompCtx^.pix_fmt:= fPixFormat;
    imageCompCtx^.width:= width;
    imageCompCtx^.height:= height;
    imageCompCtx^.time_base.den:= 1;
    imageCompCtx^.time_base.num:= 25;
    if (avcodec_open2(imageCompCtx, codec, nil) <> 0)
    then AfterCamChange;
   end else AfterCamChange;
  end else AfterCamChange;
 end;
end;

procedure TcamJpegEncoder.ProcessPacket(const aPacket: TAVPacket);
var
 frame: PAVFrame;
 pkt: TAVPacket;
 x: integer;
begin
 SyncNeeded:= False;
 if needed or not PictByPacket then inherited ProcessPacket(aPacket);
 if needed then try
  if SyncNeeded then begin
   sws_scale(previewCtx, @Data, @fLineSize, 0,
     Height, @fPreviewData, @fPreviewLineSize);
   inc(pts);
   // image
   av_init_packet(@pkt);
   pkt.data:= nil;
   pkt.size:= 0;
   frame:= av_frame_alloc();
   frame^.format:= longInt(fPixFormat);
   frame^.width:= Width;
   frame^.height:= Height;
   frame^.pts:= pts;
   for x:= 0 to AV_NUM_DATA_POINTERS - 1 do begin
    frame^.data[x]:= fData[x];
    frame^.linesize[x]:= fLineSize[x];
   end;
   x:= 0;
   if (avcodec_encode_video2(imageCompCtx, @pkt, frame, @x) = 0) and (x = 1)
   then begin
    image:= TMemoryStream.Create;
    image.Write(pkt.data^, pkt.size);
    av_free_packet(@pkt);
    image.Position:= 0;
   end else SyncNeeded:= False;
   av_frame_free(@frame);
  end;
 except
  SyncNeeded:= False;
 end;
end;

procedure TcamJpegEncoder.updImage(Sender: TObject);
begin
 if needed then try
  fOwner.ImageReady(image, PreviewData, previewWidth, previewHeight);
 except end;
 image.Free;
end;
}
//#####################################################################################

procedure RotateBitmap(Bitmap: TBitmap; Angle: integer);
type
 TRGB = record
  B, G, R, A: Byte;
 end;
 pRGB = ^TRGB;
 TRectList = array [1..4] of TPoint;

var
 W, H: Integer;
 Dest, Src: pRGB;
 Bmp: TBitmap;

 procedure SinCos(AngleRad: Double; var ASin, ACos: Double);
 begin
  ASin := Sin(AngleRad);
  ACos := Cos(AngleRad);
 end;

 function RotateRect(const Rect: TRect; const Center: TPoint; Angle: Double): TRectList;
 var
  DX, DY: Integer;
  SinAng, CosAng: Double;

  function RotPoint(PX, PY: Integer): TPoint;
  begin
   DX := PX - Center.x;
   DY := PY - Center.y;
   Result.x := Center.x + Round(DX * CosAng - DY * SinAng);
   Result.y := Center.y + Round(DX * SinAng + DY * CosAng);
  end;

 begin
  SinCos(Angle * (Pi / 180), SinAng, CosAng);
  Result[1] := RotPoint(Rect.Left, Rect.Top);
  Result[2] := RotPoint(Rect.Right, Rect.Top);
  Result[3] := RotPoint(Rect.Right, Rect.Bottom);
  Result[4] := RotPoint(Rect.Left, Rect.Bottom);
 end;

 function Min(A, B: Integer): Integer;
 begin
  if A < B then Result := A else Result := B;
 end;

 function Max(A, B: Integer): Integer;
 begin
  if A > B then Result := A else Result := B;
 end;

 function GetRLLimit(const RL: TRectList): TRect;
 begin
  Result.Left := Min(Min(RL[1].x, RL[2].x), Min(RL[3].x, RL[4].x));
  Result.Top := Min(Min(RL[1].y, RL[2].y), Min(RL[3].y, RL[4].y));
  Result.Right := Max(Max(RL[1].x, RL[2].x), Max(RL[3].x, RL[4].x));
  Result.Bottom := Max(Max(RL[1].y, RL[2].y), Max(RL[3].y, RL[4].y));
 end;

 procedure Rotate;
 var
  x, y, xr, yr, yp: Integer;
  ACos, ASin: Double;
  Lim: TRect;
 begin
  W := Bmp.Width;
  H := Bmp.Height;
  SinCos(-Angle * Pi/180, ASin, ACos);
  Lim := GetRLLimit(RotateRect(Rect(0, 0, Bmp.Width, Bmp.Height), Point(0, 0), Angle));
  Bitmap.Width := Lim.Right - Lim.Left;
  Bitmap.Height := Lim.Bottom - Lim.Top;
  Bitmap.Canvas.Brush.Color := clWhite;
  Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
  Bitmap.BeginUpdate;
  for y := 0 to Bitmap.Height - 1 do begin
   Dest := pRGB(Bitmap.RawImage.GetLineStart(y));
   yp := y + Lim.Top;
   for x := 0 to Bitmap.Width - 1 do begin
    xr := Round(((x + Lim.Left) * ACos) - (yp * ASin));
    yr := Round(((x + Lim.Left) * ASin) + (yp * ACos));
    if (xr > -1) and (xr < W) and (yr > -1) and (yr < H) then begin
     Src := pRGB(Bmp.RawImage.GetLineStart(yr));
     Inc(Src, xr);
     Dest^ := Src^;
    end;
    Inc(Dest);
   end;
  end;
  Bitmap.EndUpdate;
 end;

begin
 if Angle = 0 then exit;
 Bmp := TBitmap.Create;
 try
  Bmp.PixelFormat := pf24Bit;
  bmp.Width:= Bitmap.Width;
  Bmp.Height:= Bitmap.Height;
  Bmp.Canvas.Draw(0, 0, Bitmap);
  W := Bitmap.Width - 1;
  H := Bitmap.Height - 1;
  Bmp.BeginUpdate;
  Rotate;
  Bmp.EndUpdate;
 finally
  Bmp.Free;
 end;
end;

//####################################################################### TmainFrm

procedure TmainFrm.startBtnClick(Sender: TObject);
const
 aRatio: array [0..5] of byte = (100, 95, 105, 90, 110, 100);
var
 c, i, r: integer;
 bmp: TBitmap;
begin
 fAngle:= angleEdit.Value;
 if autoRatioCheckBox.Checked then fRatio:= aRatio[0]
 else fRatio:= round(proportionEdit.Value * 100);
 r:= 0;
 repeat
  if as0CheckBox.Checked then fRatio:= 100;
  for c:= minHeightEdit.Value to maxHeightEdit.Value do begin
   progressLabel.Caption:= IntToStr(c);
   bmp:= TBitmap.Create;
   bmp.PixelFormat:= pf24bit;
   bmp.Height:= c;
   bmp.Width:=
     round(fRatio * srcSymbImage.Picture.Graphic.Width * c / srcSymbImage.Picture.Graphic.Height / 100);
   bmp.Canvas.StretchDraw(rect(0,0, bmp.Width, bmp.Height), srcSymbImage.Picture.Graphic);
   if not quietCheckBox.Checked then begin
    resizedSymbImage.Picture.Assign(bmp);
    Update;
   end;
   if autoAngleCheckBox.Checked then for i:= - 4 to 4 do begin
    fAngle:= i;
    processLine(bmp);
   end else processLine(bmp);
   bmp.Free;
  end;
  inc(r);
  fRatio:= aRatio[r];
 until (r > 4) or not autoRatioCheckBox.Checked;
end;

procedure TmainFrm.autoAngleCheckBoxChange(Sender: TObject);
begin
 angleEdit.Enabled:= not autoAngleCheckBox.Checked;
end;

procedure TmainFrm.autoRatioCheckBoxChange(Sender: TObject);
begin
 proportionEdit.Enabled:= not autoRatioCheckBox.Checked;
end;

procedure TmainFrm.onOptimize(Sender: TObject);
var
 bmp: TBitmap;
begin
 with (TTrainingOCR(Sender)) do begin
  bmp:= TbmpGrayImage(oGraySymbol).asBitmap;
  progressLabel.Caption:= format('%s h:%u a:%d r:%u',
    [oSymbol, oSize, oAngle, oRatio]);

  if not quietCheckBox.Checked then begin
   resultSymbImage.Picture.Assign(bmp);
   Update;
   ShowMessage(oSimilarChars);
  end else progressLabel.Update;
  bmp.Free;
 end;
end;

procedure TmainFrm.Button1Click(Sender: TObject);
begin
 trainingOCR.minWeight:= 50;
 trainingOCR.Optimize(@onOptimize, TbmpGrayImage);
end;

procedure TmainFrm.clearBtnClick(Sender: TObject);
begin
 trainingOCR.ClearSymbols;
end;

procedure TmainFrm.PageControl1Change(Sender: TObject);
var
 ms: TMemoryStream;
begin
 if PageControl1.ActivePage <> TabSheet1 then begin
  ms:= TMemoryStream.Create;
  try
   trainingOCR.SaveToStream(ms);
   ms.Position:= 0;
   testOCR.LoadFromStream(ms);
  finally
   ms.Free;
  end;
 end;
 if PageControl1.ActivePage = TabSheet2 then topTrackBarChange(Sender);
 try
  //closeAllCams;
 except end;
end;

procedure TmainFrm.saveBtnClick(Sender: TObject);
var
 f: TFileStream;
begin
 f:= TFileStream.Create(ocrFN, fmCreate or fmOpenWrite);
 trainingOCR.SaveToStream(f);
 f.Free;
 ShowMessage('Saved in ' + ocrFN);
end;

procedure TmainFrm.loadPhotoBtnClick(Sender: TObject);
begin
 if OpenPhotoDialog.Execute then begin
  resultLabel.Caption:= '';
  testImage.Picture.LoadFromFile(OpenPhotoDialog.FileName);
  srcImage.Width:= defPictWidth;
  srcImage.Height:=
    testImage.Picture.Graphic.Height * srcImage.Width div
    testImage.Picture.Graphic.Width;
  srcImage.Canvas.StretchDraw(
    rect(0,0, srcImage.Width, srcImage.Height),
    testImage.Picture.Graphic);
  grayImage.CopyGraphic(srcImage);
  topTrackBarChange(Sender);
 end;
end;

procedure TmainFrm.FormCreate(Sender: TObject);
begin
 Caption:= Application.Title;
 PageControl1.PageIndex:= 0;
 grayImage:= TbmpGrayImage.Create;
 testOCR:= TplateFinder.Create;
 srcImage:= TBitmap.Create;
 with srcImage do begin
  PixelFormat:= pf24bit;
  Width:= defPictWidth;
  Height:= defPictWidth * 9 div 16;
 end;
 topTrackBarChange(Sender);
 trainingOCR:= TTrainingOCR.Create;
 trainingOCR.LoadFromFile(ocrFN);
end;

procedure TmainFrm.srcSymbImageClick(Sender: TObject);
begin
 if OpenFontPictureDialog.Execute
 then srcSymbImage.Picture.LoadFromFile(OpenFontPictureDialog.FileName);
end;

procedure TmainFrm.testBtnClick(Sender: TObject);
begin
 topTrackBarChange(Sender);
 doPrepareOCR;
 doTest;
 resultLabel.Caption:= testText;
 if testOCR.ObjectsFound then doDisplayPositions;
end;

procedure TmainFrm.testSpeedBtnClick(Sender: TObject);
const
 repeats = 10;
var
 c: integer;
 st: TDateTime;
begin
 topTrackBarChange(Sender);
 doPrepareOCR;
 st:= now;
 for c:= 1 to repeats do doTest;
 resultLabel.Caption:= trim(format('%ums %s',
   [ MilliSecondsBetween(st, now) div repeats, testText]));
 if testOCR.ObjectsFound then doDisplayPositions;
end;

procedure TmainFrm.topTrackBarChange(Sender: TObject);
begin
 resultLabel.Caption:= '';
 testImage.Picture.Assign(srcImage);
 with testImage.Picture.Bitmap.Canvas do begin
  Brush.Style:= bsClear;
  Pen.Style:= psSolid;
  Pen.Color:= clBlue;
  Rectangle(
    leftTrackBar.Position,
    topTrackBar.Position,
    rightTrackBar.Position,
    bottomTrackBar.Position);
 end;
end;

procedure TmainFrm.videoSrcEditButtonClick(Sender: TObject);
begin
// closeAllCams;
// TcamJpegEncoder.Create(getCam(videoSrcEdit.Text), Self);
end;

procedure TmainFrm.videoSrcEditChange(Sender: TObject);
begin

end;

procedure TmainFrm.weightEditChange(Sender: TObject);
begin
 resultLabel.Caption:= '';
end;

procedure TmainFrm.processLine(bmp: TBitmap);
var
 y, x1, x2,
 c, cs, cw, cn,
 lw, pw: integer;
 d: PByte;
 f: boolean;
 b: TBitmap;
 gi: TblGrImg;
begin
 cs:= length(symbolsEdit.Text);
 cw:= bmp.Width div cs;
 d:= bmp.RawImage.Data;
 lw:= bmp.RawImage.Description.BytesPerLine;
 pw:= lw div bmp.Width;
 x1:= 0;
 for c:= 0 to cs - 1 do begin
  cn:= cw + x1;
  f:= False;
  repeat
   inc(x1);
   for y:= 0 to bmp.Height - 1 do f:= f or (d[x1 * pw + y * lw] < 220);
  until (x1 = cn) or f;
  if f then begin
   x2:= x1;
   repeat
    inc(x2);
    f:= False;
    for y:= 0 to bmp.Height - 1 do f:= f or (d[x2 * pw + y * lw] < 220);
   until (x2 = bmp.Width - 1) or not f;
   b:= TBitmap.Create;
   b.Height:= bmp.Height + 2;
   b.Width:= x2 - x1 + 2;
   b.PixelFormat:= pf24bit;
   b.BeginUpdate;
   for y:= 0 to b.RawImage.DataSize - 1 do b.RawImage.Data[y]:= 255;
   b.EndUpdate;
   b.Canvas.Draw(1 - x1, 1, bmp);
   RotateBitmap(b, fAngle);
   gi:= TblGrImg.Create(b);
   gi.Blur;
   gi.Normalize;
   trainingOCR.AddSymbol(bmp.Height, fAngle, fRatio, symbolsEdit.Text[c + 1], gi);
   gi.DrawToCanvas(b.Canvas);
   gi.Free;
   progressLabel.Caption:= format('%s h:%u a:%d r:%u',
     [symbolsEdit.Text[c + 1], bmp.Height, fAngle, fRatio]);

   if not quietCheckBox.Checked then begin
    resultSymbImage.Picture.Assign(b);
    Update;
   end else progressLabel.Update;
   b.Free;
  end;
  x1:= x2 + 1;
 end;
end;

procedure TmainFrm.doTest;
begin
 testText:= '';
 if testOCR.Search(grayImage, rect(
      leftTrackBar.Position,
      topTrackBar.Position,
      rightTrackBar.Position,
      bottomTrackBar.Position))
 then testText:= testOCR.Text;
end;

procedure TmainFrm.doDisplayPositions;
var
 c: integer;
begin
 with testImage.Picture.Bitmap.Canvas, testOCR do begin
  Pen.Color:= clYellow;
  Pen.Width:= 2;
  Rectangle(PlatePosition);
  Pen.Color:= clGreen;
  Pen.Width:= 1;
  for c:= 0 to SCntr - 1 do Rectangle(SPositions[c]);
  {$ifdef debug}
  resultLabel.Caption:=
   trim(format('kwh:%u w:%u h:%u min:%u max:%u avg:%u a:%d r:%u %s', [
    PlatePosition.Width * 10 div PlatePosition.Height,
    PlatePosition.Width,
    PlatePosition.Height,
    minW, maxW, avgW, rAngle, rRate,
    resultLabel.Caption]));
  {$else}
  resultLabel.Caption:=
    trim(format('kwh:%u w:%u h:%u %s',
      [PlatePosition.Width * 10 div PlatePosition.Height,
      PlatePosition.Width, PlatePosition.Height, resultLabel.Caption]));
  {$endif}
 end;
end;

procedure TmainFrm.doPrepareOCR;
begin
 with testOCR do begin
  minWeight:= weightEdit.Value;
  minWidth:= minWEdit.Value;
  minHeight:= minHEdit.Value;
  maxWidth:= maxWEdit.Value;
  maxHeight:= maxHEdit.Value;
  minKWH:= minKWHEdit.Value;
  maxKWH:= maxKWHEdit.Value;
  tryInversion:= invCheckBox.Checked;
  tryMaxResult:= acCheckBox.Checked;
  tryRatio:= ratioCheckBox.Checked;
  tryAngle:= angleCheckBox.Checked;
 end;
end;

procedure TmainFrm.ImageReady(Image: TMemoryStream; gray: PByte; w, h: cardinal);
var
 gr: TbmpGrayImage;
 c: integer;
begin
 gr:= TbmpGrayImage.Create(w, h, gray);
 with videoImage.Picture.Bitmap do begin
  Width:= w;
  Height:= h;
  gr.DrawToCanvas(Canvas);
 end;
 if cpyToTestCheckBox.Checked
 then begin
  srcImage.Width:= w;
  srcImage.Height:= h;
  gr.DrawToCanvas(srcImage.Canvas);
 end;
 doPrepareOCR;
 //videoOCRresult.Text:= '';
 try
  if testOCR.Search(gr, rect(
       leftTrackBar.Position,
       topTrackBar.Position,
       rightTrackBar.Position,
       bottomTrackBar.Position))
  then begin
   videoOCRresult.Text:= testOCR.Text;
   videoOCRresult.Font.Color:= clWindowText;
   with videoImage.Picture.Bitmap.Canvas, testOCR do begin
    Brush.Style:= bsClear;
    Pen.Color:= clYellow;
    Pen.Width:= 2;
    Rectangle(PlatePosition);
    Pen.Color:= clGreen;
    Pen.Width:= 1;
    for c:= 0 to SCntr - 1 do Rectangle(SPositions[c]);
   end;
  end else if testOCR.ObjectsFound then begin
   videoOCRresult.Font.Color:= clGrayText;
   with videoImage.Picture.Bitmap.Canvas, testOCR do begin
    Brush.Style:= bsClear;
    Pen.Color:= clRed;
    Pen.Width:= 2;
    Rectangle(PlatePosition);
    Pen.Width:= 1;
    for c:= 0 to SCntr - 1 do begin
     {$ifdef debug}
     if SPOk[c] then Pen.Color:= clGreen else Pen.Color:= clMaroon;;
     {$endif}
     Rectangle(SPositions[c]);
    end;
   end;
  end;
 finally
  gr.Free;
 end;
end;

initialization
 {$ifdef windows}
  ocrFN:= IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + ocrFN;
 {$else}
  ocrFN:= '/tmp/' + ocrFN;
 {$endif}

end.

